=== debian/changelog ===
purple-lurch (0.6.8+git20200527.388605-3) unstable; urgency=medium

  [ Evangelos Ribeiro Tzaras ]
  * d/patches: Fix test failure on mipsel
  * d/patches: mention forwarded patches

 -- Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>  Thu, 29 Oct 2020 21:43:15 +0100

purple-lurch (0.6.8+git20200527.388605-2) unstable; urgency=medium

  * Updated VCS fields in d/control to point to the right repo
  * Added patch letting users know when message decryption failed
  * Included copyright for headers/jabber

 -- Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>  Sun, 14 Jun 2020 19:52:18 +0200

purple-lurch (0.6.8+git20200527.388605-1) unstable; urgency=medium

  * Initial release (Closes: #905883)

 -- Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>  Mon, 25 May 2020 16:58:35 +0200
