=== debian/control ===
Source: purple-lurch
Priority: optional
Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
Uploaders:
 Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>,
Build-Depends:
 debhelper-compat (= 13),
 libaxc-dev,
 libcmocka-dev,
 libomemo-dev,
 libpurple-dev,
 libsignal-protocol-c-dev,
 libxml2-dev,
Standards-Version: 4.5.0
Section: net
Homepage: https://github.com/gkdr/lurch
Vcs-Browser: https://salsa.debian.org/DebianOnMobile-team/purple-lurch
Vcs-Git: https://salsa.debian.org/DebianOnMobile-team/purple-lurch.git
Rules-Requires-Root: no

Package: purple-lurch
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: XEP-0384 OMEMO Encryption plugin for libpurple
 OMEMO is an XMPP Extension Protocl (XEP) for secure multi-client
 end-to-end encryption. It is based on Double Ratched and PEP.
 .
 This package contains the plugin for libpurple clients.
