=== debian/changelog ===
purple-lurch (0.7.0-2ubuntu3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:17:36 +1100

purple-lurch (0.7.0-2ubuntu2) noble; urgency=medium

  * Strip -Werror=implicit-function-declaration from CFLAGS.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 24 Mar 2024 10:34:04 +0100

purple-lurch (0.7.0-2ubuntu1) noble; urgency=medium

  * Fix shlibs.local file for t64 transition.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 24 Mar 2024 00:05:51 +0100

purple-lurch (0.7.0-2build2) noble; urgency=high

  * No change rebuild against libpurple0t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 17:49:38 +0100

purple-lurch (0.7.0-2build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 06:44:59 +0000

purple-lurch (0.7.0-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository, Repository-Browse.

  [ Evangelos Ribeiro Tzaras ]
  * docs: Install upstream README; Closes: #989590 (thanks Paul Wise)

 -- Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>  Thu, 13 Jul 2023 11:30:41 +0200

purple-lurch (0.7.0-1) unstable; urgency=medium

  * Declare compliance with Debian Policy 4.6.1
  * gbp.conf: Use sane defaults and document usage
  * Remove upstreamed patches
  * Update build dependencies
  * Update copyright
  * Add copyright helper script
  * Remove obsolete lintian override
  * Add libmxml-dev build dependency; Closes: #1013525 (thanks Lucas Nussbaum)
  * Add custom-library-search-path lintian override for purple dir RUNPATH

 -- Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>  Sat, 28 May 2022 21:32:43 +0200
