=== debian/control ===
--- 
+++ 
@@ -1,17 +1,21 @@
 Source: purple-lurch
 Priority: optional
-Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
 Uploaders:
  Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>,
 Build-Depends:
  debhelper-compat (= 13),
  libaxc-dev,
  libcmocka-dev,
+ libgcrypt-dev,
+ libmxml-dev,
  libomemo-dev,
  libpurple-dev,
  libsignal-protocol-c-dev,
+ libsqlite3-dev,
  libxml2-dev,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Section: net
 Homepage: https://github.com/gkdr/lurch
 Vcs-Browser: https://salsa.debian.org/DebianOnMobile-team/purple-lurch
