=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_STRIP = -Werror=implicit-function-declaration

%:
	dh $@
