=== debian/tests/control ===
Test-Command: make test
Depends:
 libgcrypt20-dev,
 libmxml-dev,
 libsqlite3-dev,
 @,
 @builddeps@,
Restrictions: allow-stderr
